/*****************************************************************************
* OS/2  PM/C Language Demo - ColorPanes
* 
*       This demo is intended for comparison with the ColoredPanes.java 
*       Magercise.
* 
* Copyright 1997, <a href=http://www.MageLang.com>MageLang Institute</a>.
******************************************************************************/
#define INCL_WIN
#define INCL_GPI

#include <os2.h>                        /* PM header file               */
#include "colrpane.h"                   /* Resource symbolic identifiers*/

static HWND CreateColorPanel(HWND hwndParent, LONG Xpos, LONG Ypos, ULONG wndID, 
                             ULONG colorID);

#define STRINGLENGTH 20                 /* Length of string             */

/*
 * Function prototypes
 */
MRESULT EXPENTRY MyWindowProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 );

                                        /* Define parameters by type    */
HAB  hab;                               /* PM anchor block handle       */
HWND hwndClient = NULLHANDLE;           /* Client area window handle    */
HWND hwndStatic1 = NULLHANDLE;          /* Static box 1 window handle   */
HWND hwndStatic2 = NULLHANDLE;          /* Static box 2 window handle   */
HWND hwndStatic3 = NULLHANDLE;          /* Static box 3 window handle   */
HWND hwndStatic4 = NULLHANDLE;          /* Static box 4 window handle   */
PSZ  pszErrMsg;


INT main (VOID)
{
  HMQ  hmq;                             /* Message queue handle         */
  HWND hwndFrame = NULLHANDLE;          /* Frame window handle          */
  QMSG qmsg;                            /* Message from message queue   */
  ULONG flCreate;                       /* Window creation control flags*/

  if ((hab = WinInitialize(0)) == 0L) /* Initialize PM     */
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

  if ((hmq = WinCreateMsgQueue( hab, 0 )) == 0L)/* Create a msg queue */
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

  if (!WinRegisterClass(                /* Register window class        */
     hab,                               /* Anchor block handle          */
     (PSZ)"MyWindow",                   /* Window class name            */
     (PFNWP)MyWindowProc,               /* Address of window procedure  */
     CS_SIZEREDRAW,                     /* Class style                  */
     0                                  /* No extra window words        */
     ))
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

   flCreate = FCF_STANDARD &            /* Set frame control flags to   */
             ~FCF_SHELLPOSITION;        /* standard except for shell    */
                                        /* positioning.                 */

  if ((hwndFrame = WinCreateStdWindow(
               HWND_DESKTOP,            /* Desktop window is parent     */
               0,                       /* STD. window styles           */
               &flCreate,               /* Frame control flag           */
               "MyWindow",              /* Client window class name     */
               "",                      /* No window text               */
               0,                       /* No special class style       */
               (HMODULE)0L,             /* Resource is in .EXE file     */
               ID_WINDOW,               /* Frame window identifier      */
               &hwndClient              /* Client window handle         */
               )) == 0L)
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

    WinSetWindowText(hwndFrame, "MageLang OS/2 Sample");

  if (!WinSetWindowPos( hwndFrame,      /* Shows and activates frame    */
                   HWND_TOP,            /* window at position 100, 100, */
                   100, 100, 300, 330,  /* and size 300, 330.           */
                   SWP_SIZE | SWP_MOVE | SWP_ACTIVATE | SWP_SHOW
                 ))
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

/*
 * Get and dispatch messages from the application message queue
 * until WinGetMsg returns FALSE, indicating a WM_QUIT message.
 */

  while( WinGetMsg( hab, &qmsg, 0L, 0, 0 ) )
    WinDispatchMsg( hab, &qmsg );
  WinDestroyWindow(hwndFrame);           /* Tidy up...                   */
  WinDestroyMsgQueue( hmq );             /* Tidy up...                   */
  WinTerminate( hab );                   /* Terminate the application    */
} /* End of main */



MRESULT EXPENTRY MyWindowProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
  LONG i;

  switch( msg )
  {
    case WM_CREATE:

      hwndStatic1 = CreateColorPanel(
                hwnd,                          /* Parent window          */
                0, 			       /* x position             */
                150,			       /* y position             */
                ID_STATIC1,                    /* Window identifier      */
                CLR_BLACK);                    /* Set the color here     */ 
      hwndStatic2 = CreateColorPanel(
                hwnd,                          /* Parent window          */
                150, 			       /* x position             */
                150,			       /* y position             */
                ID_STATIC2,                    /* Window identifier      */
                CLR_RED);                      /* Set the color here     */ 
      hwndStatic3 = CreateColorPanel(
                hwnd,                          /* Parent window          */
                0, 			       /* x position             */
                0,			       /* y position             */
                ID_STATIC3,                    /* Window identifier      */
                CLR_PINK);                     /* Set the color here     */ 
      hwndStatic4 = CreateColorPanel(
                hwnd,                          /* Parent window          */
                150, 			       /* x position             */
                0,			       /* y position             */
                ID_STATIC4,                    /* Window identifier      */
                CLR_YELLOW);                   /* Set the color here     */ 
      break;

    case WM_COMMAND:
      /*
       * When Exit is chosen, the application posts itself a WM_CLOSE
       * message.
       */
      {
         USHORT command;                   /* WM_COMMAND command value     */
         command = SHORT1FROMMP(mp1);      /* Extract the command value    */
         switch (command)
         {
           case ID_EXITPROG:
             WinPostMsg( hwnd, WM_CLOSE, (MPARAM)0, (MPARAM)0 );
             break;
           default:
             return WinDefWindowProc( hwnd, msg, mp1, mp2 );
         }

         break;
      }
    case WM_ERASEBACKGROUND:
      /*
       * Return TRUE to request PM to paint the window background
       * in SYSCLR_WINDOW.
       */
      return (MRESULT)( TRUE );
    case WM_CLOSE:
      /*
       * This is the place to put termination routines
       */
      WinPostMsg( hwnd, WM_QUIT, (MPARAM)0,(MPARAM)0 );
      break;
    default:
      return WinDefWindowProc( hwnd, msg, mp1, mp2 );
  }
  return (MRESULT)FALSE;
} /* End of MyWindowProc */

VOID AbortProgram(HWND hwndFrame, HWND hwndClient)
{
   PERRINFO  pErrInfoBlk;
   PSZ       pszOffSet;
   void      stdprint(void);

   DosBeep(100,10);
   if ((pErrInfoBlk = WinGetErrorInfo(hab)) != (PERRINFO)NULL)
   {
      pszOffSet = ((PSZ)pErrInfoBlk) + pErrInfoBlk->offaoffszMsg;
      pszErrMsg = ((PSZ)pErrInfoBlk) + *((PSHORT)pszOffSet);
      if((INT)hwndFrame && (INT)hwndClient)
         WinMessageBox(HWND_DESKTOP,         /* Parent window is desk top */
                       hwndFrame,            /* Owner window is our frame */
                       (PSZ)pszErrMsg,       /* PMWIN Error message       */
                       "Error Msg",          /* Title bar message         */
                       MSGBOXID,             /* Message identifier        */
                       MB_MOVEABLE | MB_CUACRITICAL | MB_CANCEL ); /* Flags */
      WinFreeErrorInfo(pErrInfoBlk);
   }
   WinPostMsg(hwndClient, WM_QUIT, (MPARAM)NULL, (MPARAM)NULL);
} /* End */


/*****************************************************************************
* This function emulates the subclass constructor in the Java Magercise.
*****************************************************************************/
static HWND CreateColorPanel(HWND hwndParent, LONG Xpos, LONG Ypos, ULONG wndID, 
                             ULONG colorID)
{
   HWND hwnd =
   WinCreateWindow(
                hwndParent,                    /* Parent window          */
                WC_STATIC,                     /* Window class           */
                "",                            /* Window text            */
                WS_VISIBLE |                   /* Make it visible        */
                SS_FGNDRECT,                   /* Static-text control    */
                Xpos, 			       /* x position             */
                Ypos,			       /* y position             */
                150,      		       /* Width                  */
                150,                           /* Height                 */
                hwndParent,                          /* Owner window           */
                HWND_TOP,                      /* Top of z-order         */
                wndID,                         /* Window identifier      */
                NULL,                          /* Control data           */
                NULL);                         /* Presentation parameters*/
   
   WinSetPresParam(hwnd, PP_FOREGROUNDCOLORINDEX, sizeof(colorID), &colorID);

   return hwnd;
} 