/*****************************************************************************
* OS/2  PM/C Language Demo - ColorList
* 
*       This demo is intended for comparison with the ColorChoiceApplet.java 
*       Magercise.
* 
* Copyright 1997, <a href=http://www.MageLang.com>MageLang Institute</a>.
******************************************************************************/
#define INCL_WIN
#define INCL_GPI

#include <os2.h>                        /* PM header file               */
#include <string.h>                     /* for strlen prototype         */
#include "colorlst.h"                   /* Resource symbolic identifiers*/

#define STRINGLENGTH 20                 /* Length of string             */

/*
 * Function prototypes
 */
MRESULT EXPENTRY MyWindowProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 );

                                        /* Define parameters by type    */
HAB  hab;                               /* PM anchor block handle       */
HWND hwndComboBox = NULLHANDLE;		/* Combo Box window handle      */
HWND hwndClient = NULLHANDLE;           /* Client area window handle    */
HWND hwndStatic1 = NULLHANDLE;          /* Static label 1 window handle */
HWND hwndStatic2 = NULLHANDLE;          /* Static label 2 window handle */
HWND hwndStatic3 = NULLHANDLE;          /* Static box 3 window handle   */
PCHAR szColors[] = {"black",
                   "red",
                   "green",
                   "blue",
                   "pink",
                   "yellow",
                   "gray",
                   NULL};
INT iColors[] = {CLR_BLACK,
                 CLR_RED,
                 CLR_GREEN,
                 CLR_BLUE,
                 CLR_PINK,
                 CLR_YELLOW,
                 CLR_PALEGRAY,
                 0};
CHAR szString[STRINGLENGTH];
CHAR szStatic1[] = "Color : ";
PSZ  pszErrMsg;


INT main (VOID)
{
  HMQ  hmq;                             /* Message queue handle         */
  HWND hwndFrame = NULLHANDLE;          /* Frame window handle          */
  QMSG qmsg;                            /* Message from message queue   */
  ULONG flCreate;                       /* Window creation control flags*/

  if ((hab = WinInitialize(0)) == 0L) /* Initialize PM     */
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

  if ((hmq = WinCreateMsgQueue( hab, 0 )) == 0L)/* Create a msg queue */
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

  if (!WinRegisterClass(                /* Register window class        */
     hab,                               /* Anchor block handle          */
     (PSZ)"MyWindow",                   /* Window class name            */
     (PFNWP)MyWindowProc,               /* Address of window procedure  */
     CS_SIZEREDRAW,                     /* Class style                  */
     0                                  /* No extra window words        */
     ))
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

   flCreate = FCF_STANDARD &            /* Set frame control flags to   */
             ~FCF_SHELLPOSITION;        /* standard except for shell    */
                                        /* positioning.                 */

  if ((hwndFrame = WinCreateStdWindow(
               HWND_DESKTOP,            /* Desktop window is parent     */
               0,                       /* STD. window styles           */
               &flCreate,               /* Frame control flag           */
               "MyWindow",              /* Client window class name     */
               "",                      /* No window text               */
               0,                       /* No special class style       */
               (HMODULE)0L,             /* Resource is in .EXE file     */
               ID_WINDOW,               /* Frame window identifier      */
               &hwndClient              /* Client window handle         */
               )) == 0L)
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

    WinSetWindowText(hwndFrame, "MageLang OS/2 Sample");

  if (!WinSetWindowPos( hwndFrame,      /* Shows and activates frame    */
                   HWND_TOP,            /* window at position 100, 100, */
                   100, 100, 400, 300,  /* and size 400, 300.           */
                   SWP_SIZE | SWP_MOVE | SWP_ACTIVATE | SWP_SHOW
                 ))
     AbortProgram(hwndFrame, hwndClient); /* Terminate the application    */

/*
 * Get and dispatch messages from the application message queue
 * until WinGetMsg returns FALSE, indicating a WM_QUIT message.
 */

  while( WinGetMsg( hab, &qmsg, 0L, 0, 0 ) )
    WinDispatchMsg( hab, &qmsg );
  WinDestroyWindow(hwndFrame);           /* Tidy up...                   */
  WinDestroyMsgQueue( hmq );             /* Tidy up...                   */
  WinTerminate( hab );                   /* Terminate the application    */
  return 0;
} /* End of main */



MRESULT EXPENTRY MyWindowProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
  LONG i;

  switch( msg )
  {
    case WM_CREATE:
     hwndComboBox = WinCreateWindow(hwnd,      /* Parent       */
         WC_COMBOBOX,                          /* Class        */
         "",                                   /* Name         */
         WS_VISIBLE | LS_NOADJUSTPOS,          /* Style        */
         10, 10,                               /* x, y         */
         110, 200,                             /* cx, cy       */
         hwnd,                                 /* Owner        */
         HWND_TOP,                             /* Behind       */
         ID_LISTWINDOW,                        /* ID           */
         NULL,                                 /* Control data */
         NULL);                                /* parameters   */
      /* Disable updates while filling the list. */
      WinEnableWindowUpdate(hwndComboBox, FALSE);
      for (i = 0; szColors[i]; i++) 
         WinInsertLboxItem(hwndComboBox, i, szColors[i]); 
      /* Now cause the window to update and show the new information.  */
      WinShowWindow(hwndComboBox, TRUE);

      hwndStatic1 = WinCreateWindow(
                hwnd,                          /* Parent window          */
                WC_STATIC,                     /* Window class           */
                szStatic1,                     /* Window text            */
                WS_VISIBLE |                   /* Make it visible        */
                SS_TEXT    |                   /* Static-text control    */
                DT_VCENTER |                   /* Center text vert.      */
                DT_RIGHT,                      /* Right Justify horiz.   */
                75, 			       /* x position             */
                220,			       /* y position             */
                75,      		       /* Width                  */
                20,                            /* Height                 */
                hwnd,                          /* Owner window           */
                HWND_TOP,                      /* Top of z-order         */
                ID_STATIC1,                    /* Window identifier      */
                NULL,                          /* Control data           */
                NULL);                         /* Presentation parameters*/
      hwndStatic2 = WinCreateWindow(
                hwnd,                          /* Parent window          */
                WC_STATIC,                     /* Window class           */
                szColors[0],                   /* Window text            */
                WS_VISIBLE |                   /* Make it visible        */
                SS_TEXT    |                   /* Static-text control    */
                DT_VCENTER |                   /* Center text vert.      */
                DT_LEFT,                      /* Left Justify horiz.    */
                150, 			       /* x position             */
                220,			       /* y position             */
                75,      		       /* Width                  */
                20,                            /* Height                 */
                hwnd,                          /* Owner window           */
                HWND_TOP,                      /* Top of z-order         */
                ID_STATIC2,                    /* Window identifier      */
                NULL,                          /* Control data           */
                NULL);                         /* Presentation parameters*/
      hwndStatic3 = WinCreateWindow(
                hwnd,                          /* Parent window          */
                WC_STATIC,                     /* Window class           */
                "",                            /* Window text            */
                WS_VISIBLE |                   /* Make it visible        */
                SS_FGNDRECT,                   /* Static-text control    */
                150, 			       /* x position             */
                100,			       /* y position             */
                100,      		       /* Width                  */
                100,                            /* Height                 */
                hwnd,                          /* Owner window           */
                HWND_TOP,                      /* Top of z-order         */
                ID_STATIC3,                    /* Window identifier      */
                NULL,                          /* Control data           */
                NULL);                         /* Presentation parameters*/

      break;

    case WM_COMMAND:
      /*
       * When Exit is chosen, the application posts itself a WM_CLOSE
       * message.
       */
      {
      USHORT command;                   /* WM_COMMAND command value     */
      command = SHORT1FROMMP(mp1);      /* Extract the command value    */
      switch (command)
      {
        case ID_EXITPROG:
          WinPostMsg( hwnd, WM_CLOSE, (MPARAM)0, (MPARAM)0 );
          break;
        default:
          return WinDefWindowProc( hwnd, msg, mp1, mp2 );
      }

      break;
      }
    case WM_CONTROL:
      /*
       * Handle the list box selection notification
       * message.
       */
      {
      USHORT control;                   /* WM_CONTROL control id        */
      control = SHORT1FROMMP(mp1);      /* Extract the control id       */
      switch (control)
      {
        case ID_LISTWINDOW:
          if (SHORT2FROMMP(mp1) == CBN_EFCHANGE)
          {
             ULONG ulColorIndex = 3;
             WinQueryWindowText(hwndComboBox, sizeof(szString),  szString);
             WinSetWindowText(hwndStatic2,szString);
             for (i = 0; szColors[i] && strcmp(szString, szColors[i]) != 0 ; i++);
             if (szColors[i])
             {
                ulColorIndex = (ULONG)iColors[i];
                WinSetPresParam(hwndStatic3,PP_FOREGROUNDCOLORINDEX,
                             sizeof(ulColorIndex), &ulColorIndex);
             }
          }
      }

      break;
      }
    case WM_ERASEBACKGROUND:
      /*
       * Return TRUE to request PM to paint the window background
       * in SYSCLR_WINDOW.
       */
      return (MRESULT)( TRUE );
    case WM_CLOSE:
      /*
       * This is the place to put termination routines
       */
      WinPostMsg( hwnd, WM_QUIT, (MPARAM)0,(MPARAM)0 );
      break;
    default:
      return WinDefWindowProc( hwnd, msg, mp1, mp2 );
  }
  return (MRESULT)FALSE;
} /* End of MyWindowProc */

VOID AbortProgram(HWND hwndFrame, HWND hwndClient)
{
   PERRINFO  pErrInfoBlk;
   PSZ       pszOffSet;
   void      stdprint(void);

   DosBeep(100,10);
   if ((pErrInfoBlk = WinGetErrorInfo(hab)) != (PERRINFO)NULL)
   {
      pszOffSet = ((PSZ)pErrInfoBlk) + pErrInfoBlk->offaoffszMsg;
      pszErrMsg = ((PSZ)pErrInfoBlk) + *((PSHORT)pszOffSet);
      if((INT)hwndFrame && (INT)hwndClient)
         WinMessageBox(HWND_DESKTOP,         /* Parent window is desk top */
                       hwndFrame,            /* Owner window is our frame */
                       (PSZ)pszErrMsg,       /* PMWIN Error message       */
                       "Error Msg",          /* Title bar message         */
                       MSGBOXID,             /* Message identifier        */
                       MB_MOVEABLE | MB_CUACRITICAL | MB_CANCEL ); /* Flags */
      WinFreeErrorInfo(pErrInfoBlk);
   }
   WinPostMsg(hwndClient, WM_QUIT, (MPARAM)NULL, (MPARAM)NULL);
} /* End */

